;CAML16Fu.S -- Forth Kernel
; CamelForth for the Zilog ZNEO (Z16F Series)
; portions (C) 2006 Douglas Beattie Jr.
;
; ..based on CamelForth for the Zilog Z80
; (C) 1994 Bradford J. Rodriguez
; Permission is granted to freely copy, modify,
; and distribute this program for personal or
; educational use.  Commercial inquiries should
; be directed to the author at 115 First St.,
; #105, Collingwood, Ontario L9Y 4W3, Canada
;
;
;CAML16Fu.S: Utility/Other Words
;   Source code is for the ZDS-II ZNEO 4.10.2 macro
;   assembler (provided with Zilog Developer
;   Studio II).
;
;   Forth words are documented as follows:
;*   NAME     stack -- stack    description
;   Word names in upper case are from the ANS
;   Forth Core word set.  Names in lower case are
;   "internal" implementation words & extensions.
; ===============================================


; - - - - ANSI/VT100 Terminal Support

; X AT-XY  ( x y -- )   position cursor to X,Y
;  <ESC>[{ROW};{COLUMN}H
;
    head AT_XY,5,"AT-XY",docolon
        DL LIT,27,EMIT  ;escape
        DL LIT,91,EMIT  ; '['
        DL ZDOT     ;y is ROW
        DL LIT,59,EMIT  ; ';'
        DL ZDOT
        DL LIT,72,EMIT ; 'H'
        DL EXXIT

; Z RED  --     ANSI turn console RED on black
;     27 EMIT ." [1;32;40m" ;
;
    head RED,3,"RED",docolon
        DL XSQUOTE
        DB $F-$-1,27
        DB "[1;31;40m"
$$:    .ALIGN WORDSIZE
        DL TYPE,EXXIT

; Z GREEN  --   ANSI turn console GREEN on black
;     27 EMIT ." [1;32;40m" ;
    head GREEN,5,"GREEN",docolon
        DL XSQUOTE
        DB $F-$-1,27
        DB "[1;32;40m"
$$:    .ALIGN WORDSIZE
        DL TYPE,EXXIT

; Z YELLOW  --  ANSI turn console YELLOW on black
;     27 EMIT ." [1;33;40m" ;
    head YELLOW,6,"YELLOW",docolon
        DL XSQUOTE
        DB $F-$-1,27
        DB "[1;33;40m"
$$:    .ALIGN WORDSIZE
        DL TYPE,EXXIT

; Z BLUE  --    ANSI turn console BLUE on black
;     27 EMIT ." [1;34;40m" ;
    head BLUE,4,"BLUE",docolon
        DL XSQUOTE
        DB $F-$-1,27
        DB "[1;34;40m"
$$:    .ALIGN WORDSIZE
        DL TYPE,EXXIT

; Z MAGENTA  -- ANSI turn console MAGENTA on black
;     27 EMIT ." [1;35;40m" ;
    head MAGENTA,7,"MAGENTA",docolon
        DL XSQUOTE
        DB $F-$-1,27
        DB "[1;35;40m"
$$:    .ALIGN WORDSIZE
        DL TYPE,EXXIT

; Z CYAN  --    ANSI turn console CYAN on black
;     27 EMIT ." [1;36;40m" ;
    head CYAN,4,"CYAN",docolon
        DL XSQUOTE
        DB $F-$-1,27
        DB "[1;36;40m"
$$:    .ALIGN WORDSIZE
        DL TYPE,EXXIT

; Z WHITE  --   ANSI turn console WHITE on black
;     27 EMIT ." [1;37;40m" ;
    head WHITE,5,"WHITE",docolon
        DL XSQUOTE
        DB $F-$-1,27
        DB "[1;37;40m"
$$:    .ALIGN WORDSIZE
        DL TYPE,EXXIT

;IMPORTANT: words at offset 4 and 7 at U0 need to be placed
; back in UINIT data before any save of a new system!
; SAVEU will ensure that when you later execute the saved binary,
; the user's compiled words will be accessable.
;
;Z SAVEU -- save User DP and previous
;    HERE   UINIT 8 + !  ( save DP, current dictionary pointer )
;    LATEST @ UINIT 14 + ! ;    ( save LATEST, most-recent definition)
;
; (Note: This will only work if the kernel is running from RAM.)
;
        head SAVEU,5,"SAVEU",docolon

        DL  HERE,UINIT,LIT,4*CELLSIZE,PLUS,STORE
        DL  LATEST,FETCH,UINIT,LIT,7*CELLSIZE,PLUS,STORE
        DL  EXXIT

